Index: .hgignore
===================================================================
--- .hgignore	(revision 249)
+++ .hgignore	(revision 298)
@@ -30,4 +30,5 @@
 syntax: regexp
 (.*/)?\#[^/]*\#$
+(.*/)?\.\#[^/]*$
 ^doc/html/.*
 ^doc/.*\.tag
Index: AUTHORS
===================================================================
--- AUTHORS	(revision 320)
+++ AUTHORS	(revision 320)
@@ -0,0 +1,26 @@
+The authors of the 1.x series are
+
+ * Balazs Dezso <deba@inf.elte.hu>
+ * Alpar Juttner <alpar@cs.elte.hu>
+ * Peter Kovacs <kpeter@inf.elte.hu>
+ * Akos Ladanyi <ladanyi@tmit.bme.hu>
+
+For more details on the actual contribution, please visit the history
+of the main LEMON source repository: http://lemon.cs.elte.hu/hg/lemon
+
+Moreover, this version is heavily based on the 0.x series of
+LEMON. Here is the list of people who contributed to those versions.
+
+ * Mihaly Barasz <klao@cs.elte.hu>
+ * Johanna Becker <beckerjc@cs.elte.hu>
+ * Attila Bernath <athos@cs.elte.hu>
+ * Balazs Dezso <deba@inf.elte.hu>
+ * Peter Hegyi <hegyi@tmit.bme.hu>
+ * Alpar Juttner <alpar@cs.elte.hu>
+ * Peter Kovacs <kpeter@inf.elte.hu>
+ * Akos Ladanyi <ladanyi@tmit.bme.hu>
+ * Marton Makai <marci@cs.elte.hu>
+ * Jacint Szabo <jacint@cs.elte.hu>
+
+Again, please visit the history of the old LEMON repository for more
+details: http://lemon.cs.elte.hu/svn/lemon/trunk
Index: CMakeLists.txt
===================================================================
--- CMakeLists.txt	(revision 236)
+++ CMakeLists.txt	(revision 274)
@@ -1,15 +1,6 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
 
-#EXECUTE_PROCESS(
-#  COMMAND hg id -i
-#  OUTPUT_VARIABLE HG_REVISION
-#  OUTPUT_STRIP_TRAILING_WHITESPACE)
-
 SET(PROJECT_NAME "LEMON")
-SET(PROJECT_VERSION_MAJOR "0")
-SET(PROJECT_VERSION_MINOR "99")
-SET(PROJECT_VERSION_PATCH "0")
-SET(PROJECT_VERSION
-  "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
+SET(PROJECT_VERSION "hg-tip" CACHE STRING "The version string.")
 
 PROJECT(${PROJECT_NAME})
@@ -40,13 +31,10 @@
   SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE")
 
-  SET(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
-  SET(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
-  SET(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})
   SET(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
 
   SET(CPACK_PACKAGE_INSTALL_DIRECTORY
-    "${PROJECT_NAME} ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
+    "${PROJECT_NAME} ${PROJECT_VERSION}")
   SET(CPACK_PACKAGE_INSTALL_REGISTRY_KEY
-    "${PROJECT_NAME} ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
+    "${PROJECT_NAME} ${PROJECT_VERSION}")
 
   # Variables to generate a component-based installer.
Index: INSTALL
===================================================================
--- INSTALL	(revision 245)
+++ INSTALL	(revision 318)
@@ -2,9 +2,9 @@
 =========================
 
-   Since you are reading this I assume you already obtained one of the release
+Since you are reading this I assume you already obtained one of the release
 tarballs and successfully extracted it. The latest version of LEMON is
 available at our web page (http://lemon.cs.elte.hu/).
 
-   In order to install LEMON from the extracted source tarball you have to
+In order to install LEMON from the extracted source tarball you have to
 issue the following commands:
 
@@ -22,6 +22,6 @@
 
       This command compiles the non-template part of LEMON into libemon.a
-      file. It also compiles the programs in the tools, benchmark and demo
-      subdirectories when enabled.
+      file. It also compiles the programs in the tools and demo subdirectories
+      when enabled.
 
    4. `make check'
@@ -50,10 +50,10 @@
 ===============================
 
-   In step 2 you can customize the actions of configure by setting variables
+In step 2 you can customize the actions of configure by setting variables
 and passing options to it. This can be done like this:
 `./configure [OPTION]... [VARIABLE=VALUE]...'
 
-   Below you will find some useful variables and options (see
-`./configure --help' for more):
+Below you will find some useful variables and options (see `./configure --help'
+for more):
 
 CXX='comp'
@@ -77,12 +77,4 @@
 
    Do not build the examples in the demo subdirectory (default).
-
---enable-benchmark
-
-   Build the programs in the benchmark subdirectory.
-
---disable-benchmark
-
-   Do not build the programs in the benchmark subdirectory (default).
 
 --enable-tools
Index: Makefile.am
===================================================================
--- Makefile.am	(revision 227)
+++ Makefile.am	(revision 321)
@@ -5,4 +5,5 @@
 
 EXTRA_DIST = \
+	AUTHORS \
 	LICENSE \
 	m4/lx_check_cplex.m4 \
@@ -25,4 +26,5 @@
 bin_PROGRAMS =
 check_PROGRAMS =
+dist_bin_SCRIPTS =
 TESTS =
 XFAIL_TESTS =
@@ -32,5 +34,4 @@
 include doc/Makefile.am
 include demo/Makefile.am
-include benchmark/Makefile.am
 include tools/Makefile.am
 
Index: NEWS
===================================================================
--- NEWS	(revision 5)
+++ NEWS	(revision 322)
@@ -0,0 +1,50 @@
+2008-10-13 Version 1.0 released
+
+	This is the first stable release of LEMON. Compared to the 0.x
+	release series, it features a considerably smaller but more
+	matured set of tools. The API has also completely revised and
+	changed in several places.
+
+	* The major name changes compared to the 0.x series (see the
+          Migration Guide in the doc for more details)
+          * Graph -> Digraph, UGraph -> Graph
+          * Edge -> Arc, UEdge -> Edge
+	  * source(UEdge)/target(UEdge) -> u(Edge)/v(Edge)
+	* Other improvements
+	  * Better documentation
+	  * Reviewed and cleaned up codebase
+	  * CMake based build system (along with the autotools based one)
+	* Contents of the library (ported from 0.x)
+	  * Algorithms
+       	    * breadth-first search (bfs.h)
+       	    * depth-first search (dfs.h)
+       	    * Dijkstra's algorithm (dijkstra.h)
+       	    * Kruskal's algorithm (kruskal.h)
+    	  * Data structures
+       	    * graph data structures (list_graph.h, smart_graph.h)
+       	    * path data structures (path.h)
+       	    * binary heap data structure (bin_heap.h)
+       	    * union-find data structures (unionfind.h)
+       	    * miscellaneous property maps (maps.h)
+       	    * two dimensional vector and bounding box (dim2.h)
+          * Concepts
+       	    * graph structure concepts (concepts/digraph.h, concepts/graph.h,
+              concepts/graph_components.h)
+       	    * concepts for other structures (concepts/heap.h, concepts/maps.h,
+	      concepts/path.h)
+    	  * Tools
+       	    * Mersenne twister random number generator (random.h)
+       	    * tools for measuring cpu and wall clock time (time_measure.h)
+       	    * tools for counting steps and events (counter.h)
+       	    * tool for parsing command line arguments (arg_parser.h)
+       	    * tool for visualizing graphs (graph_to_eps.h)
+       	    * tools for reading and writing data in LEMON Graph Format
+              (lgf_reader.h, lgf_writer.h)
+            * tools to handle the anomalies of calculations with
+	      floating point numbers (tolerance.h)
+            * tools to manage RGB colors (color.h)
+    	  * Infrastructure
+       	    * extended assertion handling (assert.h)
+       	    * exception classes and error handling (error.h)
+      	    * concept checking (concept_check.h)
+       	    * commonly used mathematical constants (math.h)
Index: README
===================================================================
--- README	(revision 246)
+++ README	(revision 318)
@@ -36,9 +36,5 @@
 test/
 
-   Contains programs to check the integrity and correctness of LEMON.
-
-benchmark/
-  
-   Contains programs for measuring the performance of algorithms.
+   Programs to check the integrity and correctness of LEMON.
 
 tools/
Index: configure.ac
===================================================================
--- configure.ac	(revision 236)
+++ configure.ac	(revision 310)
@@ -2,7 +2,13 @@
 
 dnl Version information.
-m4_define([lemon_version_number], [])
+m4_define([lemon_version_number],
+	[m4_normalize(esyscmd([echo ${LEMON_VERSION}]))])
+dnl m4_define([lemon_version_number], [])
+m4_define([lemon_hg_path], [m4_normalize(esyscmd([./scripts/chg-len.py]))])
 m4_define([lemon_hg_revision], [m4_normalize(esyscmd([hg id -i]))])
-m4_define([lemon_version], [ifelse(lemon_version_number(), [], [lemon_hg_revision()], [lemon_version_number()])])
+m4_define([lemon_version], [ifelse(lemon_version_number(),
+			   [],
+			   [lemon_hg_path().lemon_hg_revision()],
+			   [lemon_version_number()])])
 
 AC_PREREQ([2.59])
@@ -16,4 +22,7 @@
 lx_cmdline_cxxflags_set=${CXXFLAGS+set}
 
+dnl Do compilation tests using the C++ compiler.
+AC_LANG([C++])
+
 dnl Checks for programs.
 AC_PROG_CXX
@@ -26,13 +35,24 @@
 AC_CHECK_PROG([gs_found],[gs],[yes],[no])
 
+dnl Detect Intel compiler.
+AC_MSG_CHECKING([whether we are using the Intel C++ compiler])
+AC_COMPILE_IFELSE([#ifndef __INTEL_COMPILER
+choke me
+#endif], [ICC=[yes]], [ICC=[no]])
+if test x"$ICC" = x"yes"; then
+  AC_MSG_RESULT([yes])
+else
+  AC_MSG_RESULT([no])
+fi
+
 dnl Set custom compiler flags when using g++.
-if test x"$lx_cmdline_cxxflags_set" != x"set" -a "$GXX" = yes; then
+if test x"$lx_cmdline_cxxflags_set" != x"set" -a "$GXX" = yes -a "$ICC" = no; then
   CXXFLAGS="$CXXFLAGS -Wall -W -Wall -W -Wunused -Wformat=2 -Wctor-dtor-privacy -Wnon-virtual-dtor -Wno-char-subscripts -Wwrite-strings -Wno-char-subscripts -Wreturn-type -Wcast-qual -Wcast-align -Wsign-promo -Woverloaded-virtual -Woverloaded-virtual -ansi -fno-strict-aliasing -Wold-style-cast -Wno-unknown-pragmas"
 fi
 
 dnl Checks for libraries.
-LX_CHECK_GLPK
-LX_CHECK_CPLEX
-LX_CHECK_SOPLEX
+#LX_CHECK_GLPK
+#LX_CHECK_CPLEX
+#LX_CHECK_SOPLEX
 
 dnl Disable/enable building the demo programs.
@@ -61,17 +81,4 @@
 fi
 AM_CONDITIONAL([WANT_TOOLS], [test x"$enable_tools" != x"no"])
-
-dnl Disable/enable building the benchmarks.
-AC_ARG_ENABLE([benchmark],
-AS_HELP_STRING([--enable-benchmark], [build the benchmarks])
-AS_HELP_STRING([--disable-benchmark], [do not build the benchmarks @<:@default@:>@]),
-              [], [enable_benchmark=no])
-AC_MSG_CHECKING([whether to build the benchmarks])
-if test x"$enable_benchmark" != x"no"; then
-  AC_MSG_RESULT([yes])
-else
-  AC_MSG_RESULT([no])
-fi
-AM_CONDITIONAL([WANT_BENCHMARK], [test x"$enable_benchmark" != x"no"])
 
 dnl Checks for header files.
@@ -109,9 +116,8 @@
 echo C++ compiles flags............ : $CXXFLAGS
 echo
-echo GLPK support.................. : $lx_glpk_found
-echo CPLEX support................. : $lx_cplex_found
-echo SOPLEX support................ : $lx_soplex_found
-echo
-echo Build benchmarks.............. : $enable_benchmark
+#echo GLPK support.................. : $lx_glpk_found
+#echo CPLEX support................. : $lx_cplex_found
+#echo SOPLEX support................ : $lx_soplex_found
+#echo
 echo Build demo programs........... : $enable_demo
 echo Build additional tools........ : $enable_tools
Index: demo/arg_parser_demo.cc
===================================================================
--- demo/arg_parser_demo.cc	(revision 209)
+++ demo/arg_parser_demo.cc	(revision 311)
@@ -28,5 +28,5 @@
 
 using namespace lemon;
-int main(int argc, const char **argv)
+int main(int argc, char **argv)
 {
   // Initialize the argument parser
Index: demo/graph_to_eps_demo.cc
===================================================================
--- demo/graph_to_eps_demo.cc	(revision 220)
+++ demo/graph_to_eps_demo.cc	(revision 313)
@@ -27,5 +27,5 @@
 /// how to handle parallel egdes, how to change the properties (like
 /// color, shape, size, title etc.) of nodes and arcs individually
-/// using appropriate \ref maps-page "graph maps".
+/// using appropriate graph maps.
 ///
 /// \include graph_to_eps_demo.cc
Index: demo/lgf_demo.cc
===================================================================
--- demo/lgf_demo.cc	(revision 209)
+++ demo/lgf_demo.cc	(revision 294)
@@ -45,10 +45,10 @@
 
   try {
-    digraphReader("digraph.lgf", g). // read the directed graph into g
+    digraphReader(g, "digraph.lgf"). // read the directed graph into g
       arcMap("capacity", cap).       // read the 'capacity' arc map into cap
       node("source", s).             // read 'source' node to s
       node("target", t).             // read 'target' node to t
       run();
-  } catch (DataFormatError& error) { // check if there was any error
+  } catch (Exception& error) { // check if there was any error
     std::cerr << "Error: " << error.what() << std::endl;
     return -1;
@@ -61,5 +61,5 @@
   std::cout << "We can write it to the standard output:" << std::endl;
 
-  digraphWriter(std::cout, g).     // write g to the standard output
+  digraphWriter(g).                // write g to the standard output
     arcMap("capacity", cap).       // write cap into 'capacity'
     node("source", s).             // write s to 'source'
Index: doc/Doxyfile.in
===================================================================
--- doc/Doxyfile.in	(revision 226)
+++ doc/Doxyfile.in	(revision 316)
@@ -1,3 +1,3 @@
-# Doxyfile 1.5.5
+# Doxyfile 1.5.7.1
 
 #---------------------------------------------------------------------------
@@ -34,7 +34,9 @@
 CPP_CLI_SUPPORT        = NO
 SIP_SUPPORT            = NO
+IDL_PROPERTY_SUPPORT   = YES
 DISTRIBUTE_GROUP_DOC   = NO
 SUBGROUPING            = YES
 TYPEDEF_HIDES_STRUCT   = NO
+SYMBOL_CACHE_SIZE      = 0
 #---------------------------------------------------------------------------
 # Build related configuration options
@@ -67,5 +69,8 @@
 SHOW_USED_FILES        = YES
 SHOW_DIRECTORIES       = YES
+SHOW_FILES             = YES
+SHOW_NAMESPACES        = YES
 FILE_VERSION_FILTER    = 
+LAYOUT_FILE            = DoxygenLayout.xml
 #---------------------------------------------------------------------------
 # configuration options related to warning and progress messages
@@ -76,5 +81,5 @@
 WARN_IF_DOC_ERROR      = YES
 WARN_NO_PARAMDOC       = NO
-WARN_FORMAT            = "$file:$line: $text  "
+WARN_FORMAT            = "$file:$line: $text"
 WARN_LOGFILE           = doxygen.log
 #---------------------------------------------------------------------------
@@ -134,18 +139,25 @@
 HTML_STYLESHEET        = 
 HTML_ALIGN_MEMBERS     = YES
-GENERATE_HTMLHELP      = NO
+HTML_DYNAMIC_SECTIONS  = NO
 GENERATE_DOCSET        = NO
 DOCSET_FEEDNAME        = "Doxygen generated docs"
 DOCSET_BUNDLE_ID       = org.doxygen.Project
-HTML_DYNAMIC_SECTIONS  = NO
+GENERATE_HTMLHELP      = NO
 CHM_FILE               = 
 HHC_LOCATION           = 
 GENERATE_CHI           = NO
+CHM_INDEX_ENCODING     = 
 BINARY_TOC             = NO
 TOC_EXPAND             = NO
+GENERATE_QHP           = NO
+QCH_FILE               = 
+QHP_NAMESPACE          = org.doxygen.Project
+QHP_VIRTUAL_FOLDER     = doc
+QHG_LOCATION           = 
 DISABLE_INDEX          = NO
 ENUM_VALUES_PER_LINE   = 4
 GENERATE_TREEVIEW      = NO
 TREEVIEW_WIDTH         = 250
+FORMULA_FONTSIZE       = 10
 #---------------------------------------------------------------------------
 # configuration options related to the LaTeX output
@@ -222,8 +234,11 @@
 # Configuration options related to the dot tool   
 #---------------------------------------------------------------------------
-CLASS_DIAGRAMS         = NO
+CLASS_DIAGRAMS         = YES
 MSCGEN_PATH            = 
 HIDE_UNDOC_RELATIONS   = YES
 HAVE_DOT               = YES
+DOT_FONTNAME           = FreeSans
+DOT_FONTSIZE           = 10
+DOT_FONTPATH           = 
 CLASS_GRAPH            = YES
 COLLABORATION_GRAPH    = NO
Index: doc/Makefile.am
===================================================================
--- doc/Makefile.am	(revision 347)
+++ doc/Makefile.am	(revision 349)
@@ -1,4 +1,5 @@
 EXTRA_DIST += \
 	doc/Doxyfile.in \
+	doc/DoxygenLayout.xml \
 	doc/coding_style.dox \
 	doc/dirs.dox \
@@ -7,4 +8,6 @@
 	doc/license.dox \
 	doc/mainpage.dox \
+	doc/migration.dox \
+	doc/named-param.dox \
 	doc/namespaces.dox \
 	doc/html \
Index: doc/dirs.dox
===================================================================
--- doc/dirs.dox	(revision 209)
+++ doc/dirs.dox	(revision 318)
@@ -19,7 +19,7 @@
 /**
 \dir demo
-\brief A collection of demo application.
+\brief A collection of demo applications.
 
-This directory contains several simple demo application, mainly
+This directory contains several simple demo applications, mainly
 for educational purposes.
 */
@@ -29,5 +29,6 @@
 \brief Auxiliary (and the whole generated) documentation.
 
-Auxiliary (and the whole generated) documentation.
+This directory contains some auxiliary pages and the whole generated
+documentation.
 */
 
@@ -42,17 +43,14 @@
 /**
 \dir tools
-\brief Some useful executables
+\brief Some useful executables.
 
 This directory contains the sources of some useful complete executables.
-
 */
-
-
 
 /**
 \dir lemon
-\brief Base include directory of LEMON
+\brief Base include directory of LEMON.
 
-This is the base directory of lemon includes, so each include file must be
+This is the base directory of LEMON includes, so each include file must be
 prefixed with this, e.g.
 \code
@@ -64,16 +62,16 @@
 /**
 \dir concepts
-\brief Concept descriptors and checking classes
+\brief Concept descriptors and checking classes.
 
-This directory contains the concept descriptors and concept checkers. As a user
-you typically don't have to deal with these files.
+This directory contains the concept descriptors and concept checking tools.
+For more information see the \ref concept "Concepts" module.
 */
 
 /**
 \dir bits
-\brief Implementation helper files
+\brief Auxiliary tools for implementation.
 
-This directory contains some helper classes to implement graphs, maps and
-some other classes. As a user you typically don't have to deal with these
-files.
+This directory contains some auxiliary classes for implementing graphs, 
+maps and some other classes.
+As a user you typically don't have to deal with these files.
 */
Index: doc/groups.dox
===================================================================
--- doc/groups.dox	(revision 236)
+++ doc/groups.dox	(revision 318)
@@ -55,5 +55,7 @@
 You are free to use the graph structure that fit your requirements
 the best, most graph algorithms and auxiliary data structures can be used
-with any graph structures.
+with any graph structure.
+
+<b>See also:</b> \ref graph_concepts "Graph Structure Concepts".
 */
 
@@ -75,6 +77,8 @@
 This group describes the map structures implemented in LEMON.
 
-LEMON provides several special purpose maps that e.g. combine
+LEMON provides several special purpose maps and map adaptors that e.g. combine
 new maps from existing ones.
+
+<b>See also:</b> \ref map_concepts "Map Concepts".
 */
 
@@ -87,5 +91,4 @@
 values to the nodes and arcs of graphs.
 */
-
 
 /**
@@ -105,5 +108,5 @@
 algorithms.  If a function type algorithm is called then the function
 type map adaptors can be used comfortable. For example let's see the
-usage of map adaptors with the \c digraphToEps() function.
+usage of map adaptors with the \c graphToEps() function.
 \code
   Color nodeColor(int deg) {
@@ -119,5 +122,5 @@
   Digraph::NodeMap<int> degree_map(graph);
 
-  digraphToEps(graph, "graph.eps")
+  graphToEps(graph, "graph.eps")
     .coords(coords).scaleToA4().undirected()
     .nodeColors(composeMap(functorToMap(nodeColor), degree_map))
@@ -125,5 +128,5 @@
 \endcode
 The \c functorToMap() function makes an \c int to \c Color map from the
-\e nodeColor() function. The \c composeMap() compose the \e degree_map
+\c nodeColor() function. The \c composeMap() compose the \c degree_map
 and the previously created map. The composed map is a proper function to
 get the color of each node.
@@ -163,5 +166,5 @@
 @defgroup paths Path Structures
 @ingroup datas
-\brief Path structures implemented in LEMON.
+\brief %Path structures implemented in LEMON.
 
 This group describes the path structures implemented in LEMON.
@@ -174,5 +177,4 @@
 
 \sa lemon::concepts::Path
-
 */
 
@@ -186,5 +188,4 @@
 */
 
-
 /**
 @defgroup algs Algorithms
@@ -202,9 +203,9 @@
 
 This group describes the common graph search algorithms like
-Breadth-first search (Bfs) and Depth-first search (Dfs).
-*/
-
-/**
-@defgroup shortest_path Shortest Path algorithms
+Breadth-First Search (BFS) and Depth-First Search (DFS).
+*/
+
+/**
+@defgroup shortest_path Shortest Path Algorithms
 @ingroup algs
 \brief Algorithms for finding shortest paths.
@@ -214,5 +215,5 @@
 
 /**
-@defgroup max_flow Maximum Flow algorithms
+@defgroup max_flow Maximum Flow Algorithms
 @ingroup algs
 \brief Algorithms for finding maximum flows.
@@ -242,9 +243,8 @@
 provides functions to query the minimum cut, which is the dual linear
 programming problem of the maximum flow.
-
-*/
-
-/**
-@defgroup min_cost_flow Minimum Cost Flow algorithms
+*/
+
+/**
+@defgroup min_cost_flow Minimum Cost Flow Algorithms
 @ingroup algs
 
@@ -256,5 +256,5 @@
 
 /**
-@defgroup min_cut Minimum Cut algorithms
+@defgroup min_cut Minimum Cut Algorithms
 @ingroup algs
 
@@ -283,9 +283,8 @@
 If you want to find minimum cut just between two distinict nodes,
 please see the \ref max_flow "Maximum Flow page".
-
-*/
-
-/**
-@defgroup graph_prop Connectivity and other graph properties
+*/
+
+/**
+@defgroup graph_prop Connectivity and Other Graph Properties
 @ingroup algs
 \brief Algorithms for discovering the graph properties
@@ -299,5 +298,5 @@
 
 /**
-@defgroup planar Planarity embedding and drawing
+@defgroup planar Planarity Embedding and Drawing
 @ingroup algs
 \brief Algorithms for planarity checking, embedding and drawing
@@ -311,5 +310,5 @@
 
 /**
-@defgroup matching Matching algorithms
+@defgroup matching Matching Algorithms
 @ingroup algs
 \brief Algorithms for finding matchings in graphs and bipartite graphs.
@@ -349,9 +348,8 @@
 \image html bipartite_matching.png
 \image latex bipartite_matching.eps "Bipartite Matching" width=\textwidth
-
-*/
-
-/**
-@defgroup spantree Minimum Spanning Tree algorithms
+*/
+
+/**
+@defgroup spantree Minimum Spanning Tree Algorithms
 @ingroup algs
 \brief Algorithms for finding a minimum cost spanning tree in a graph.
@@ -361,7 +359,6 @@
 */
 
-
-/**
-@defgroup auxalg Auxiliary algorithms
+/**
+@defgroup auxalg Auxiliary Algorithms
 @ingroup algs
 \brief Auxiliary algorithms implemented in LEMON.
@@ -372,5 +369,6 @@
 
 /**
-@defgroup approx Approximation algorithms
+@defgroup approx Approximation Algorithms
+@ingroup algs
 \brief Approximation algorithms.
 
@@ -386,9 +384,8 @@
 This group describes some general optimization frameworks
 implemented in LEMON.
-
-*/
-
-/**
-@defgroup lp_group Lp and Mip solvers
+*/
+
+/**
+@defgroup lp_group Lp and Mip Solvers
 @ingroup gen_opt_group
 \brief Lp and Mip solver interfaces for LEMON.
@@ -397,9 +394,8 @@
 various LP solvers could be used in the same manner with this
 interface.
-
-*/
-
-/**
-@defgroup lp_utils Tools for Lp and Mip solvers
+*/
+
+/**
+@defgroup lp_utils Tools for Lp and Mip Solvers
 @ingroup lp_group
 \brief Helper tools to the Lp and Mip solvers.
@@ -442,5 +438,5 @@
 
 /**
-@defgroup timecount Time measuring and Counting
+@defgroup timecount Time Measuring and Counting
 @ingroup misc
 \brief Simple tools for measuring the performance of algorithms.
@@ -448,13 +444,4 @@
 This group describes simple tools for measuring the performance
 of algorithms.
-*/
-
-/**
-@defgroup graphbits Tools for Graph Implementation
-@ingroup utils
-\brief Tools to make it easier to create graphs.
-
-This group describes the tools that makes it easier to create graphs and
-the maps that dynamically update with the graph changes.
 */
 
@@ -472,6 +459,7 @@
 
 This group describes the tools for importing and exporting graphs
-and graph related data. Now it supports the LEMON format, the
-\c DIMACS format and the encapsulated postscript (EPS) format.
+and graph related data. Now it supports the \ref lgf-format
+"LEMON Graph Format", the \c DIMACS format and the encapsulated
+postscript (EPS) format.
 */
 
@@ -479,5 +467,5 @@
 @defgroup lemon_io LEMON Input-Output
 @ingroup io_group
-\brief Reading and writing \ref lgf-format "LEMON Graph Format".
+\brief Reading and writing LEMON Graph Format.
 
 This group describes methods for reading and writing
@@ -486,5 +474,5 @@
 
 /**
-@defgroup eps_io Postscript exporting
+@defgroup eps_io Postscript Exporting
 @ingroup io_group
 \brief General \c EPS drawer and graph exporter
@@ -494,5 +482,4 @@
 */
 
-
 /**
 @defgroup concept Concepts
@@ -504,10 +491,10 @@
 The purpose of the classes in this group is fourfold.
 
-- These classes contain the documentations of the concepts. In order
+- These classes contain the documentations of the %concepts. In order
   to avoid document multiplications, an implementation of a concept
   simply refers to the corresponding concept class.
 
 - These classes declare every functions, <tt>typedef</tt>s etc. an
-  implementation of the concepts should provide, however completely
+  implementation of the %concepts should provide, however completely
   without implementations and real data structures behind the
   interface. On the other hand they should provide nothing else. All
@@ -522,7 +509,5 @@
 
 - Finally, They can serve as a skeleton of a new implementation of a concept.
-
-*/
-
+*/
 
 /**
@@ -535,8 +520,10 @@
 */
 
-/* --- Unused group
-@defgroup experimental Experimental Structures and Algorithms
-This group describes some Experimental structures and algorithms.
-The stuff here is subject to change.
+/**
+@defgroup map_concepts Map Concepts
+@ingroup concept
+\brief Skeleton and concept checking classes for maps
+
+This group describes the skeletons and concept checking classes of maps.
 */
 
Index: doc/lgf.dox
===================================================================
--- doc/lgf.dox	(revision 236)
+++ doc/lgf.dox	(revision 313)
@@ -79,5 +79,5 @@
 \endcode
 
-The \c \@edges is just a synonym of \c \@arcs. The @arcs section can
+The \c \@edges is just a synonym of \c \@arcs. The \@arcs section can
 also store the edge set of an undirected graph. In such case there is
 a conventional method for store arc maps in the file, if two columns
Index: doc/mainpage.dox
===================================================================
--- doc/mainpage.dox	(revision 209)
+++ doc/mainpage.dox	(revision 314)
@@ -51,5 +51,5 @@
 If you
 want to see how LEMON works, see
-some \ref demoprograms "demo programs"!
+some \ref demoprograms "demo programs".
 
 If you know what you are looking for then try to find it under the
@@ -57,4 +57,5 @@
 section.
 
-
+If you are a user of the old (0.x) series of LEMON, please check out the
+\ref migration "Migration Guide" for the backward incompatibilities.
 */
